class OriginalPictureLicenseGroupsController < ApplicationController
  before_action :authenticate_user, :only => [:new, :create]
  before_action :authenticate_artist, :only => [:new, :create]
  
  def new
    @original_picture = OriginalPicture.show params[:original_picture_id], @operators
    @item = OriginalPictureLicenseGroup.new()
    @item.supply_default @original_picture.id
    
    respond_to do |format|
      format.html {
        @form = Locmare::Bucket.factory @item.item_name, 'default', @item, true, true, @operators
      }
      format.json { render json: @item.to_json }
    end
  end
  
  def create
    @my_model_class = OriginalPictureLicenseGroup
    
    @item = @my_model_class.new
    @my_model_class.fold_extend_settings params[@my_model_class.item_name]
    @item.attributes = @item.permit_params params
    @item.overwrite 
    @original_picture = OriginalPicture.show @item.original_picture, @operators
    
    if @item.valid?
      # switch my_model_class
      @item = OriginalPictureLicenseGroup.build_original_picture_license @item, nil, @operators
      respond_to do |format|
        format.html {
          @form = Locmare::Bucket.factory @item.item_name, 'default', @item, true, true, @operators
          render :template => @item.path_name + '/new'
        }
        format.json {
          render json: @item.to_json(), status: :created, location: @item
        }
      end
    else
      respond_to do |format|
        format.html {
          @form = Locmare::Bucket.factory @item.item_name, 'default', @item, true, true, @operators
          render action: "new"
        }
        format.json {
          render json: @item.errors, status: :unprocessable_entity
        }
      end
    end
  end

end
