module Manifest
  module ModelModule
    module AssociationModule
      class HasOne < ManifestBase::NameValues
        attr :item_name, :foreign_key
        
        def set_default
          super
          @values['item_name'] ||= @name
          @values['foreign_key'] ||= @parent.item_name + '_id'
        end
        
        def init
          super
          @item_name = @values['item_name']
          @foreign_key = @values['foreign_key']
        end
        
        def through?
          @through.blank? == false
        end
        
        def model
          ::Manifest.item_name_to_model @item_name
        end
        
      end
      
    end
  end
end
